blob: 8afd9c22ca1ff3eb35e36bb8c4af4560f7032ce0 [file] [log] [blame]
tierno7edb6752016-03-21 17:37:52 +01001#!/bin/bash
2
3##
4# Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
24DBUSER="mano"
25DBPASS=""
26DBHOST="localhost"
27DBPORT="3306"
28DBNAME="mano_db"
garciadeblas0c317ee2016-08-29 12:33:06 +020029CREATEDB=""
tierno7edb6752016-03-21 17:37:52 +010030
31# Detect paths
32MYSQL=$(which mysql)
33AWK=$(which awk)
34GREP=$(which grep)
35DIRNAME=`dirname $0`
36
37function usage(){
38 echo -e "Usage: $0 OPTIONS"
39 echo -e " Inits openmano database; deletes previous one and loads from ${DBNAME}_structure.sql"
40 echo -e " OPTIONS"
41 echo -e " -u USER database user. '$DBUSER' by default. Prompts if DB access fails"
42 echo -e " -p PASS database password. 'No password' by default. Prompts if DB access fails"
43 echo -e " -P PORT database port. '$DBPORT' by default"
44 echo -e " -h HOST database host. '$DBHOST' by default"
tierno462e3882016-07-06 17:52:14 +020045 echo -e " -d NAME database name. '$DBNAME' by default. Prompts if DB access fails"
tierno7edb6752016-03-21 17:37:52 +010046 echo -e " --help shows this help"
garciadeblas0c317ee2016-08-29 12:33:06 +020047 echo -e " --createdb forces the deletion and creation of the database"
tierno7edb6752016-03-21 17:37:52 +010048}
49
tierno462e3882016-07-06 17:52:14 +020050while getopts ":u:p:P:d:h:-:" o; do
tierno7edb6752016-03-21 17:37:52 +010051 case "${o}" in
52 u)
53 DBUSER="$OPTARG"
54 ;;
55 p)
56 DBPASS="$OPTARG"
57 ;;
58 P)
59 DBPORT="$OPTARG"
60 ;;
tierno462e3882016-07-06 17:52:14 +020061 d)
62 DBNAME="$OPTARG"
63 ;;
tierno7edb6752016-03-21 17:37:52 +010064 h)
65 DBHOST="$OPTARG"
66 ;;
67 -)
garciadeblas0c317ee2016-08-29 12:33:06 +020068 if [ "${OPTARG}" == "help" ]; then
69 usage && exit 0
70 elif [ "${OPTARG}" == "createdb" ]; then
71 CREATEDB="yes"
72 else
73 echo "Invalid option: --$OPTARG" >&2 && usage >&2
74 exit 1
75 fi
tierno7edb6752016-03-21 17:37:52 +010076 ;;
77 \?)
78 echo "Invalid option: -$OPTARG" >&2 && usage >&2
79 exit 1
80 ;;
81 :)
82 echo "Option -$OPTARG requires an argument." >&2 && usage >&2
83 exit 1
84 ;;
85 *)
86 usage >&2
87 exit -1
88 ;;
89 esac
90done
91shift $((OPTIND-1))
92
93#check and ask for database user password
94DBUSER_="-u$DBUSER"
95DBPASS_=""
96[ -n "$DBPASS" ] && DBPASS_="-p$DBPASS"
97DBHOST_="-h$DBHOST"
98DBPORT_="-P$DBPORT"
99while ! echo ";" | mysql $DBHOST_ $DBPORT_ $DBUSER_ $DBPASS_ >/dev/null 2>&1
100do
101 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
102 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
103# read -e -p "mysql database name($DBNAME): " KK
104# [ -n "$KK" ] && DBNAME="$KK"
105 read -e -p "mysql user($DBUSER): " KK
106 [ -n "$KK" ] && DBUSER="$KK" && DBUSER_="-u$DBUSER"
107 read -e -s -p "mysql password: " DBPASS
108 [ -n "$DBPASS" ] && DBPASS_="-p$DBPASS"
109 [ -z "$DBPASS" ] && DBPASS_=""
110 logintry="yes"
111 echo
112done
113
garciadeblas0c317ee2016-08-29 12:33:06 +0200114if [ -n "${CREATEDB}" ]; then
115 echo " deleting previous database ${DBNAME}"
116 echo "DROP DATABASE IF EXISTS ${DBNAME}" | mysql $DBHOST_ $DBPORT_ $DBUSER_ $DBPASS_
117 echo " creating database ${DBNAME}"
118 mysqladmin $DBUSER_ $DBPASS_ -s create ${DBNAME} || exit 1
119fi
120
tierno7edb6752016-03-21 17:37:52 +0100121echo " loading ${DIRNAME}/${DBNAME}_structure.sql"
tierno462e3882016-07-06 17:52:14 +0200122mysql $DBHOST_ $DBPORT_ $DBUSER_ $DBPASS_ $DBNAME < ${DIRNAME}/mano_db_structure.sql
tierno7edb6752016-03-21 17:37:52 +0100123
124echo " migrage database version"
125${DIRNAME}/migrate_mano_db.sh $DBHOST_ $DBPORT_ $DBUSER_ $DBPASS_ -d$DBNAME
126